
.define INCR 1
.define DECR 0
.define VERT 0
.define HORIZ 1
.define incmode(x) (x<<4)+0
.define wrapmode(x) (x<<5)+0
.define movemode(x) (x<<3)+0
.define bgrmode(x) (x<<12)+0
.define origin(x) (x<<7)+0
.define msb(adr) ((adr>>8)&$FF)+0
.define lsb(adr) (adr&$FF)+0
.define combhilo(hi,lo) (256*hi)+lo

.define xy(x,y) (256*(y))+(x)+0
.define wh(w,h) (256*((h)-1))+((w)-1)+0

;//For memory utilities. Assumes mem_utils is defined
;//textShadow on 84+CSE is 260 bytes.
userMemPtr           = textshadow ;rolling pointer for compile-time mem alloc
allocRtnCount        = 0          ;for keeping track of allocations for routines
allocRtnLoopSeal     = 0          ;toggles to ensure reloc2 loops are not nested
;//For "labelname" use an undefined label to define 
.deflong allocMem(size,labelname)
    .ifdef mem_utils_table
        .fail "Cannot alloc after tbl define in mem_utils.z80!"
    .endif
    labelname = userMemPtr
    labelname{_size} = (size)
    tvar1 = userMemPtr + (size)
    userMemPtr = tvar1
.enddeflong

allocMem(1,empty)
allocMem(1,intTimer)
allocMem(2,intExtern)
allocMem(1,cpage)
allocMem(1,curKey)
allocMem(1,prevKey)
allocMem(1,keyDelay)
allocMem(1,keyBufLen)
allocMem(16,keyBuffer)
allocMem(1,curscreen)
allocMem(1,bgcolor)
allocMem(3,quickExit)
allocMem(1,ap_bits)
allocMem(1,ap_byte)
allocMem(1,lwm)
allocMem(2,r_0)
allocMem(1,textx)
allocMem(1,texty)
allocMem(1,menuopt)
allocMem(1,prevmenuopt)
allocMem(1,lheight)
allocMem(1,prevx)
allocMem(1,splashlen)
allocMem(1,newLevelCounter)

allocMem(1,curlev)
allocMem(1,maxlev)
allocMem(2,levsetadr)
;//Do not seperate these values or change their order as level data
;//is LDIR'd directly into all these variables
allocMem(1,curx)
allocMem(1,cury)
allocMem(1,curdir)
allocMem(1,curdiff)
allocMem(8*6,levarray)
;//---
allocMem(2,prevtbladr)

allocMem(2,flagbank_address)
;// These two flagtables must be defined in this order.
allocMem(16,flagtable_classic)
allocMem(16,flagtable_extra)

;//Flags
myflags .equ asm_flag1
water_rendering    .equ 0
ready_to_rerender  .equ 1
is_new_stage       .equ 2
game_completed     .equ 3



;//Constants
STATUSBG   .equ 64
SPACEBG    .equ 130
ERRORBG    .equ 12
BLACKBG    .equ 0
WHITEBG    .equ 255

TRANS_COLOR .equ 248

PAGE_FONT   .equ 4
PAGE_GAME   .equ 4
PAGE_TITLE  .equ 5
PAGE_LEVELS .equ 6

adr_font   .equ $C000
adr_game   .equ $C000+(9*128)
adr_title  .equ $C000
adr_levels .equ $C000

adr_base_levels .equ adr_levels
adr_ex_levels .equ adr_levels+8000


dsk_up    .equ $F7  ;// 0
dsk_right .equ $FB  ;// 1
dsk_left  .equ $FD  ;// 2
dsk_down  .equ $FE  ;// 3
dsk_del   .equ $7F  ;// 4
dsk_mode  .equ $BF  ;// 5
dsk_2nd   .equ $DF  ;// 6
dsk_yequ  .equ $EF  ;// 7

frog_up    .equ 1
frog_left  .equ 2
frog_right .equ 3
frog_down  .equ 4


DIR0 .equ frog_up
DIR1 .equ frog_down
DIR2 .equ frog_left
DIR3 .equ frog_right

LINE_HEIGHT .equ 12

.define m_EOF 0
.define m_newline 1
.define m_setlh(x) 2,x
.define m_addx(x) 3,x

.define printf(adr) call printfmacro \.dw adr
.define getmenuopt(nn) call getmenuoptmacro \.db nn
.define add1ToHL(nn) call addDat1ToHL \.db nn
.define drawbox(x,y,w,h,c) call DrawBoxMacro \.db x,y,w,h,c

obj_lily1  .equ 0
obj_lily2  .equ 7
obj_water  .equ 6
obj_rock   .equ 8
obj_splash .equ 9

SPLASH_TIME_TO_LIVE .equ 3


